
QGIS Application - Feature request #19784

make the "Delete Ring" Tool work also by clicking on the ring boundaries

2018-09-06 11:25 AM - na na

Status: Open

Priority: Normal

Assignee:

Category: Digitising

Pull Request or Patch supplied:No Resolution:

Easy fix?: No Copied to github as #: 27609

Description

Windows 10 Home

x64

Summary:

Delete Ring Tool not deleting thin rings if area of ring very small, thin rings.

Can delete rings if ring has significant area .

Can select vertex/nodes using node tool, so vertex/nodes go blue, then press Delete

on keyboard seems to work as a workaround.

Affects: 3.2.1-1 and QGIS 2.18.23, QGIS 2.18.22, QGIS 2.14.15

Ring tool worked in QGIS 2.2

Tests on QGIS 3.2.1-1:

    -  Uninstall QGIS 2.18.23 on laptop, using revo uninstaller.

    -  C:\Users\Username\.qgis2 delete folder

    -  Restart machine

    -  Install QGIS 3.2.1-1 x64 standalong from QGIS.org

    -  Clean installation, no other non standard programs/plugins installed

    -  Right click on Menu, Enable: Advanced Digitizing Toolbar, remove Browser Panel

Test 1 - FAIL

    -  Create new polygon layer using new shapefile layer button, set as Polygon, WGS 84, EPSG:4326

    -  Toggle Editing enabled

    -  Create new polygon using Add Feature Button

    -  Create ring that is thin (Picture A) using Add Ring Button

    -  Try to delete using delete ring, delete doesn't work

Test 1b - SUCCESS

    -  Try to delete ring that has a significant area/white space created in same way as Test 1 (Picture

B)

    -  Left click on ring with Delete Ring Button, ring deleted

Test 2 - FAILS

Copy file I know has rings after merging polygons together.  I think rings generated from I think from poor splitting of polygons with

incorrect snapping options enabled, try to delete rings after merging

    -  Import sph file, Data Source Manager Button, Vector, WGS 84 projection, encoding utf-8, ADD

    -  Toggle Editing Enable

    -  Select features, select Polygons, Press Merge Selected Features button

    -  Get rings like this (Picture C)

    -  Try to delete using delete ring button, this fails
Test 3 - Deleted

    -  Select nodes using node tool by drawing a square so vertex/nodes go blue (Picture D)

    -  Then press Delete button on keyboard, thin ring deleted.

History

#1 - 2018-09-06 11:30 AM - Giovanni Manghi

- Priority changed from Normal to High

- Status changed from Open to Feedback

Please attach sample data.

Does works as expected on 2.18?

#2 - 2018-09-06 11:48 AM - na na

- File Polygon with thin ring.zip added

Giovanni Manghi wrote:

Please attach sample data.

Does works as expected on 2.18?

Does not work as expected on 2.18.22 or 2.18.23

Sorry have attached shp files as zip file for Tests 1, 1b and probably Test 3

The shp files for Test 2 would be difficult to upload.

#3 - 2018-09-06 11:53 AM - na na

- Status changed from Feedback to Open

#4 - 2018-09-06 11:58 AM - Giovanni Manghi

- Priority changed from High to Normal

- Regression? changed from Yes to No

#5 - 2018-09-06 12:09 PM - Giovanni Manghi

Tom T wrote:

Giovanni Manghi wrote:

Please attach sample data.

Does works as expected on 2.18?

Does not work as expected on 2.18.22 or 2.18.23

Sorry have attached shp files as zip file for Tests 1, 1b and probably Test 3

The shp files for Test 2 would be difficult to upload.

I downloaded the dataset, is empty.
#6 - 2018-09-06 01:08 PM - na na

- File Polygon with thin ring_USE THIS.zip added

Giovanni Manghi wrote:

Tom T wrote:

Giovanni Manghi wrote:

Please attach sample data.

Does works as expected on 2.18?

Does not work as expected on 2.18.22 or 2.18.23

Sorry have attached shp files as zip file for Tests 1, 1b and probably Test 3

The shp files for Test 2 would be difficult to upload.

I downloaded the dataset, is empty.

Sorry, Corrected file attached, annoyed as I should have spotted that.

Shp files generated from QGIS 2.18.22

#7 - 2018-09-06 03:03 PM - Giovanni Manghi

- Status changed from Open to Feedback

Sorry, Corrected file attached, annoyed as I should have spotted that.

Shp files generated from QGIS 2.18.22

I zoomed in enough to see the hole, clicking in with the tool and is gone.

#8 - 2018-09-10 11:52 AM - na na

- File Picture E view of the thin rings on a modified shp file.PNG added

- File Modified shp file for Test 2.zip added

- Status changed from Feedback to Open

Ok, though there are normally more than 1 thin ring at one time.  I think it is impractical to zoom in on each ring in order to delete the rings.  I would think

that users work on multiple polygons, shapes at any one time?  I think we need the delete ring tool to work on larger scales when you can see multiple

polygons ect... see Picture E view of the thin rings on a modified shp file.

I was trying to replicate "thin rings" using add ring button, (which is still a bug for the delete ring button at larger scales)

I have modified the file I used for Test 2 (Modified shp file for Test 2.zip)

This is the file where I found rings after merging polygons together. I think rings generated from I think from poor splitting of polygons with incorrect

snapping options enabled.

This Modified shp file for Test 2 should give a better example file, I can't zoom in and delete the rings, at least in QGIS 2.18.22

If you see any personal information please delete this zip, but I believe there shouldn't be any personal information on these files.
#9 - 2018-09-11 01:59 PM - Giovanni Manghi

- Status changed from Open to Feedback

Tom T wrote:

Ok, though there are normally more than 1 thin ring at one time.  I think it is impractical to zoom in on each ring in order to delete the rings.  I would

think that users work on multiple polygons, shapes at any one time?  I think we need the delete ring tool to work on larger scales when you can see

multiple polygons ect... see Picture E view of the thin rings on a modified shp file.

I was trying to replicate "thin rings" using add ring button, (which is still a bug for the delete ring button at larger scales)

I have modified the file I used for Test 2 (Modified shp file for Test 2.zip)

This is the file where I found rings after merging polygons together. I think rings generated from I think from poor splitting of polygons with incorrect

snapping options enabled.

This Modified shp file for Test 2 should give a better example file, I can't zoom in and delete the rings, at least in QGIS 2.18.22

If you see any personal information please delete this zip, but I believe there shouldn't be any personal information on these files.

this digitizing tools is there specifically to allow remove by hand one by one those rings. If you need to remove a bunch of them you can use the "delete

holes" tool in the Processing toolbox. If you get them by dissolving features that should be adjacent but they are not, then use the GRASS dissolve tool and

its advanced option "snapping".

#10 - 2018-09-11 03:55 PM - na na

- Status changed from Feedback to Open

Giovanni Manghi wrote:

Tom T wrote:

Ok, though there are normally more than 1 thin ring at one time.  I think it is impractical to zoom in on each ring in order to delete the rings.  I would

think that users work on multiple polygons, shapes at any one time?  I think we need the delete ring tool to work on larger scales when you can see

multiple polygons ect... see Picture E view of the thin rings on a modified shp file.

I was trying to replicate "thin rings" using add ring button, (which is still a bug for the delete ring button at larger scales)

I have modified the file I used for Test 2 (Modified shp file for Test 2.zip)

This is the file where I found rings after merging polygons together. I think rings generated from I think from poor splitting of polygons with incorrect

snapping options enabled.

This Modified shp file for Test 2 should give a better example file, I can't zoom in and delete the rings, at least in QGIS 2.18.22

If you see any personal information please delete this zip, but I believe there shouldn't be any personal information on these files.

this digitizing tools is there specifically to allow remove by hand one by one those rings. If you need to remove a bunch of them you can use the

"delete holes" tool in the Processing toolbox. If you get them by dissolving features that should be adjacent but they are not, then use the GRASS

dissolve tool and its advanced option "snapping".

*Edit Grammar

Thanks, I see what you are saying, though I disagree a bit.  Have you had any success deleting the thin rings using the Delete Ring Button for this ERSI

shape file: modified shp file for Test 2?
I would like to keep multiple ways of deleting rings/thin rings at various/larger scales, like I think we can with other functions.

I like the ability to just quickly delete the rings I find on a one to one basis (large scales) on the occasion I merge some polygons together on a layer.  This

avoids create new layers using Processing Toolbox, Delete Rings.

This is partly because I think explaining how to use/using the delete ring tool to users is easier than how to use GRASS.

Though using the Processing Toolbox, Delete Rings is reasonably easy to explain/and I assume use. :-)

#11 - 2018-09-11 04:08 PM - Giovanni Manghi

- Status changed from Open to Feedback

Have you had any success deleting the thin rings using the Delete Ring Button for this ERSI shape file: modified shp file for Test 2?

yes

#12 - 2018-09-11 05:20 PM - na na

Giovanni Manghi wrote:

Have you had any success deleting the thin rings using the Delete Ring Button for this ERSI shape file: modified shp file for Test 2?

yes

Could you please explain how?

Using these files, I can't delete the rings using the delete ring button on QGIS 3.2.2-1, you zoom in to 25:1 or so, I can't delete a ring.

Enabled snapping by default in Setting, Options, Digitizing

Hopefully I am not drawing this conversation out too much.  Thanks

#13 - 2018-09-12 04:33 PM - Giovanni Manghi

Tom T wrote:

Giovanni Manghi wrote:

Have you had any success deleting the thin rings using the Delete Ring Button for this ERSI shape file: modified shp file for Test 2?

yes

Could you please explain how?

the tool works when clicking on the "area" of a hole... so just use the node to move one of the nodes, expose the hole "area" and use the delete hole tool.

#14 - 2018-09-12 04:56 PM - na na

Giovanni Manghi wrote:
Tom T wrote:

Giovanni Manghi wrote:

Have you had any success deleting the thin rings using the Delete Ring Button for this ERSI shape file: modified shp file for Test 2?

yes

Could you please explain how?

the tool works when clicking on the "area" of a hole... so just use the node to move one of the nodes, expose the hole "area" and use the delete hole

tool.

Thanks for clarifying, though my bug still exists.  My bug is about not being able to delete thin rings/0/small areas.

I think the tool has generally worked if you can see an "area" of a hole.  I have done "the tool works when clicking on the "area" of a hole... so just use the

node to move one of the nodes, expose the hole "area" and use the delete hole tool." in the past.

If the tool won't delete thin rings, we will just need to use the node tool.  Just seems silly that the delete ring tool can't delete thin rings (islands)

though, hence my bug request. Thanks

#15 - 2018-09-12 05:06 PM - Giovanni Manghi

Thanks for clarifying, though my bug still exists.  My bug is about not being able to delete thin rings/0/small areas.

if you don't want to zoom like crazy and use the delete ring tool (That works for me) use the proposed workaround.

To remove batched of zero areas rings/polygons use automated tools

#16 - 2018-09-14 02:32 PM - na na

- Status changed from Feedback to Open

Giovanni Manghi wrote:

Thanks for clarifying, though my bug still exists.  My bug is about not being able to delete thin rings/0/small areas.

if you don't want to zoom like crazy and use the delete ring tool (That works for me) use the proposed workaround.

To remove batched of zero areas rings/polygons use automated tools

Yeah... :-) I just disagree a bit, I don't think you should need to modify the thin ring using the node tool for the delete ring to work.

As stated before: I would like to keep multiple ways of deleting rings/thin rings at various/larger scales, like I think we can with other functions.

I like the ability to just quickly delete the rings I find on a one to one basis (large scales) on the occasion I merge some polygons together on a layer. This

avoids create new layers using Processing Toolbox, Delete Rings.

Though this is an open source program, so I would need to build support for fixing this, as I'm not the one doing the work! :-)  However I think other users

could/do agree with me, there is a stackexchange ticket saying that the ring tool isn't working.

Thanks
#17 - 2018-09-14 06:28 PM - Harrissou Santanna

However I think other users could/do agree with me, there is a stackexchange ticket saying that the ring tool isn't working.

/me cheeky. It's not because it's said on stackExchange that it's true. And I do not agree that it's not working; it works the way it's designed. The "Delete

ring" tool requires you to click within the ring to get it removed. This means that on thin rings you need to enlarge the rings and then delete them. Which I

fully agree is not optimal and a real waste of time.

Maybe It could be improved so that it removes rings that are within a certain tolerance of the clicked coordinate? A feature request?

Meanwhile, Tom, another workaround can be to draw a rough polygon that covers the ring but still within the main polygon and merge both later...

#18 - 2018-09-14 06:36 PM - Giovanni Manghi

- Status changed from Open to Feedback

Harrissou Santanna wrote:

This means that on thin rings you need to enlarge the rings and then delete them. Which I fully agree is not optimal and a real waste of time.

I ALSO agree, but please notice that on older QGIS releases the worked when clicking on the boundaries of the hole, not inside the hole itself. This was

ALSO considered cumbersome by many, so it was changed.

I guess that this ticket should really become a feature request asking to restore the old way to work, or implement both.

#19 - 2018-10-01 10:34 AM - na na

Harrissou Santanna wrote:

Meanwhile, Tom, another workaround can be to draw a rough polygon that covers the ring but still within the main polygon and merge both later...

Thank you, I see what you mean about the "way it is designed"

Giovanni Manghi wrote:

Harrissou Santanna wrote:

This means that on thin rings you need to enlarge the rings and then delete them. Which I fully agree is not optimal and a real waste of time.

I ALSO agree, but please notice that on older QGIS releases the worked when clicking on the boundaries of the hole, not inside the hole itself. This

was ALSO considered cumbersome by many, so it was changed.

I guess that this ticket should really become a feature request asking to restore the old way to work, or implement both.

Can we implement both to make users who want both functionality?  Or maybe have 2 delete ring tools, One "Delete Ring" (click inside hole) and "Delete

line Ring" (click on boundaries)

I can change this to a feature requests if that helps?
#20 - 2018-10-01 05:46 PM - Giovanni Manghi

- Subject changed from Delete Ring Tool not working on thin rings to make the "Delete Ring" Tool work also by clicking on the ring boundaries

- Tracker changed from Bug report to Feature request

- Status changed from Feedback to Open

Files

Picture B ring with significant area.PNG 5.19 KB 2018-09-06 na na

Picture A Thin Ring.PNG 4.48 KB 2018-09-06 na na

Picture C Thin ring on shp file has rings from merging.PNG 1.19 KB 2018-09-06 na na

Picture D Select ring using node tool not work on shp file that has rings.PNG1.92 KB 2018-09-06 na na

Polygon with thin ring.zip 2.59 KB 2018-09-06 na na

Polygon with thin ring_USE THIS.zip 1.34 KB 2018-09-06 na na

Modified shp file for Test 2.zip 2.83 KB 2018-09-10 na na

Picture E view of the thin rings on a modified shp file.PNG 22.3 KB 2018-09-10 na na

2025-04-28 8/8


